const {
    version
} = require('./constants')
const path = require('path')
const program = require('commander')

const mapAction = {
    create: {
        alias: "c",
        description: "create a project",
        examples: ["lying-cli create <project-name>"]
    },
    config: {
        alias: "conf",
        description: "config project variable",
        examples: ["lying-cli config set <k><v>"]
    },
    "*": {
        alias: "",
        description: "command is not found",
        examples: []
    }
}

// 循环创建命令
Reflect.ownKeys(mapAction).forEach(action => {
    program.command(action) // 配置命令的名称
    .alias(mapAction[action].alias) // 别名
    .description(mapAction[action].description) // 描述
    .action(() => {
        if (action === "*"){
            // 无此命令
            console.log(mapAction[action].description)
        }else{
            // 截取命令 lying-cli create xx
            console.log(path.resolve(__dirname,action))
            require(path.resolve(__dirname,action))(...process.argv.slice(3))
        }
    })
})

// 监听用户 help事件
program.on('--help',() => {
    console.log("\nExamples: ")
    Reflect.ownKeys(mapAction).forEach(action => {
        mapAction[action].examples.forEach(example => {
            console.log(`  ${example}`)
        })
    })
})

program.version(`@lying-cli ${version}`).parse(process.argv)